<?php
  /**************************************************************************\
  * phpGroupWare - Calendar                                                  *
  * http://www.phpgroupware.org                                              *
  * Written by Mark Peters <skeeter@phpgroupware.org>                        *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

	/* $Id: class.boicalendar.inc.php,v 1.16.2.4 2002/06/24 09:52:54 skeeter Exp $ */

	class boXport
	{
		var $public_functions = array(
			'import' => True,
			'export' => True
		);

		var $bo;

		var $start;
		var $limit;
		var $query;
		var $sort;
		var $order;
		var $filter;
		var $cat_id;

		var $use_session = False;

		function boXport ($session=False)
		{
			$this->bo = CreateObject('calendar.bocalendar');
			global $start,$limit,$query,$sort,$order,$filter,$cat_id;

			if($start || $start == 0)  { $this->start = $start; }
			if($limit)  { $this->limit  = $limit;  }
			if($query)  { $this->query  = $query;  }
			if($sort)   { $this->sort   = $sort;   }
			if($order)  { $this->order  = $order;  }
			if($filter) { $this->filter = $filter; }
			$this->cat_id = $cat_id;
		}

		function import($tsvfile,$conv_type,$private,$fcat_id)
		{
			include (PHPGW_APP_INC . '/import/' . $conv_type);

			if ($private == '') { $private = 'public'; }
			$row = 0;
			$buffer = array();
			$eventsimport = new import_conv;

			$buffer = $eventsimport->import_start_file($buffer);
			$fp = fopen($tsvfile,'r');
			if ($eventsimport->type == 'csv')
			{
				while ($data = fgetcsv($fp,8000,','))
				{
					$num = count($data);
					$row++;
					if ($row == 1)
					{
						$header = $data;
					}
					else
					{
						$buffer = $eventsimport->import_start_record($buffer);
						for ($c=0; $c<$num; $c++ )
						{
							//Send name/value pairs along with the buffer
							if ($eventsimport->import[$header[$c]] != '' && $data[$c] != '')
							{
								$buffer = $eventsimport->import_new_attrib($buffer, $eventsimport->import[$header[$c]],$data[$c]);
							}
						}
						$buffer = $eventsimport->import_end_record($buffer,$private);
					}
				}
			}

			fclose($fp);
			$buffer = $eventsimport->import_end_file($buffer,$private,$fcat_id);
			return $buffer;
		}

		function export($params, $conv_type, $cat_id='')
		{
			$events = $this->bo->store_to_cache($params);

			include (PHPGW_APP_INC . '/export/' . $conv_type);
			$buffer=array();
			$eventsexport = new export_conv;

			$buffer = $eventsexport->export_start_file($buffer);
	
			foreach($events as $day=>$eventsperday)
			{
			//	echo $day."<br/><br/>";
				if(is_array($eventsperday))
				{
					foreach ($eventsperday as $event)
					{
						$buffer = $eventsexport->export_start_record($buffer);
						foreach($event as $key => $value)
						{
//							echo $key.":";
							switch ($key)
							{
								case 'public':
								{
									$buffer = $eventsexport->export_new_attrib($buffer,'private',$value?0:1);
									break;
								}
								case 'owner':
								{
									$GLOBALS['phpgw']->accounts->get_account_name($value,$lid,$fname,$lname);
									$name = $fname.' '.$lname;
									$buffer = $eventsexport->export_new_attrib($buffer,$key,$name);
									break;
								}
								case 'participants':
								{
									if (count($event['participants']) > 0)
									{
										@reset($event['participants']);
										$str_participants = '';
										while(list($part,$status) = each($event['participants']))
										{
											$GLOBALS['phpgw']->accounts->get_account_name($part,$lid,$fname,$lname);
											$name = $fname.' '.$lname;
											$str_participants .= $name.', ';
										}
										$str_participants = substr($str_participants,0,-2);
										$buffer = $eventsexport->export_new_attrib($buffer,$key,$str_participants);
									}
									break;
								}
								case 'start':
								case 'end':
								{
									$so_event = $this->bo->so;
									$dt_mktime = $so_event->maketime($value);
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.year',date('Y',$dt_mktime));
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.mday',date('d',$dt_mktime));
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.month',date('m',$dt_mktime));
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.min',date('i',$dt_mktime));
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.sec',date('s',$dt_mktime));
									$buffer = $eventsexport->export_new_attrib($buffer,$key.'.hour',date('H',$dt_mktime));
									break;
								}
								default:
								{
									if (is_array($value))
									{
										foreach($value as $key2 => $value2)
										{
											$buffer = $eventsexport->export_new_attrib($buffer,$key.'.'.$key2,$value2);
//											echo "&nbsp;$nbsp;".$key2.":".$value2."<br/>";
										}
									}
									else
									{
					//					echo $value."<br/>";
										$buffer = $eventsexport->export_new_attrib($buffer,$key,$value);
									}
									break;
								}
							}
						}
						$so_event = $this->bo->so;
						if ($so_event->maketime($event['start']) - $so_event->maketime($event['end']) == 0 && $event['start']['hour'] == 0)
							$buffer = $eventsexport->export_new_attrib($buffer,'All day event','1');
						$buffer = $eventsexport->export_end_record($buffer);
					}
				}
			}

			// Here, buffer becomes a string suitable for printing
			$buffer = $eventsexport->export_end_file($buffer);

			$tsvfilename = $GLOBALS['phpgw_info']['server']['temp_dir'] . SEP . $tsvfilename;

			return $buffer;
		}


	}
?>
