<?php
  /**************************************************************************\
  * phpGroupWare - Calendar                                                  *
  * http://www.phpgroupware.org                                              *
  * Based on Webcalendar by Craig Knudsen <cknudsen@radix.net>               *
  *          http://www.radix.net/~cknudsen                                  *
  * Modified by Mark Peters <skeeter@phpgroupware.org>                       *
  * --------------------------------------------                             *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/

	/* $Id: class.uicalendar.inc.php,v 1.66.2.21 2002/08/25 04:07:48 skeeter Exp $ */

	class uiXport
	{
		var $template;
		var $public_functions = array(
			'export' => True
		);
		var $bo;
		var $cat;

		var $start;
		var $limit;
		var $query;
		var $sort;
		var $order;
		var $filter;
		var $cat_id;

		function uiXport()
		{
			$this->template = $GLOBALS['phpgw']->template;
			$this->cat      = CreateObject('phpgwapi.categories');
			$this->bo       = CreateObject('calendar.boXport',True);
			$this->browser  = CreateObject('phpgwapi.browser');

			$this->start    = $this->bo->start;
			$this->limit    = $this->bo->limit;
			$this->query    = $this->bo->query;
			$this->sort     = $this->bo->sort;
			$this->order    = $this->bo->order;
			$this->filter   = $this->bo->filter;
			$this->cat_id   = $this->bo->cat_id;
		}

		function export()
		{
			global $convert,$tsvfilename,$cat_id,$download,$conv_type,$startdate,$enddate;

			if ($convert)
			{
				if ($conv_type == 'none')
				{
					$GLOBALS['phpgw_info']['flags']['noheader'] = False;
					$GLOBALS['phpgw_info']['flags']['noheader'] = True;
					$GLOBALS['phpgw']->common->phpgw_header();
					echo parse_navbar();
					echo lang('<b>No conversion type &lt;none&gt; could be located.</b>  Please choose a conversion type from the list');
					echo '&nbsp<a href="'.$GLOBALS['phpgw']->link('/index.php','menuaction=calendar.uiXport.export') . '">' . lang('OK') . '</a>';
					$GLOBALS['phpgw']->common->phpgw_footer();
					$GLOBALS['phpgw']->common->phpgw_exit();
				}

				$params = Array(
					'syear'		=> $startdate['year'],
					'smonth'	=> $startdate['month'],
					'sday'		=> $startdate['mday'],
					'eyear'		=> $enddate['year'],
					'emonth'	=> $enddate['month'],
					'eday'		=> $enddate['mday']);
						
				$buffer = $this->bo->export($params, $conv_type);

				if(($download == 'on') || ($conv_type == 'Palm_PDB') )
				{
					// filename, default application/octet-stream, length of file, default nocache True
					$this->browser->content_header($tsvfilename,'text/comma-separated-values',strlen($buffer));
					echo $buffer;
					exit();
				}
				else
				{
					$GLOBALS['phpgw']->common->phpgw_header();
					echo parse_navbar();
					echo "<pre>\n";
					echo $buffer;
					echo "\n</pre>\n";
					echo '<a href="'.$GLOBALS['phpgw']->link('/index.php','menuaction=calendar.uiXport.export') . '">' . lang('OK') . '</a>';
					$GLOBALS['phpgw']->common->phpgw_footer();
				}
			}
			else
			{

				unset($GLOBALS['phpgw_info']['flags']['noheader']);
				unset($GLOBALS['phpgw_info']['flags']['nonavbar']);
				$GLOBALS['phpgw_info']['flags']['nonappheader'] = True;
				$GLOBALS['phpgw_info']['flags']['nonappfooter'] = True;
				$GLOBALS['phpgw']->common->phpgw_header();

				if(!@is_dir($GLOBALS['phpgw_info']['server']['temp_dir']))
				{
					mkdir($GLOBALS['phpgw_info']['server']['temp_dir'],0700);
				}

				echo '<body bgcolor="' . $GLOBALS['phpgw_info']['theme']['bg_color'] . '">';

				$dir_handle = opendir(PHPGW_APP_INC. SEP . 'export');
				$i=0; $myfilearray = '';
				while ($file = readdir($dir_handle))
				{
					if ((substr($file, 0, 1) != '.') && is_file(PHPGW_APP_INC . SEP . 'export' . SEP . $file) )
					{
						$myfilearray[$i] = $file;
						$i++;
					}
				}
				closedir($dir_handle);
				sort($myfilearray);
				for ($i=0;$i<count($myfilearray);$i++)
				{
					$fname = ereg_replace('_',' ',$myfilearray[$i]);
					$conv .= '        <option value="'.$myfilearray[$i].'">'.$fname.'</option>'."\n";
				}

				if ($GLOBALS['HTTP_GET_VARS']['action'] == 'GetFile')
				{
					echo '<b><center>' . lang('You must select a [iv]Cal. (*.[iv]cs)') . '</b></center><br><br>';
				}

 				$this->template->set_file(
 					Array(
 						'export' => 'export.tpl'
 					)
 				);

				$today = date('Ymd',$GLOBALS['phpgw']->datetime->users_localtime);
				$syear = intval(substr($today,0,4));
				$smonth = intval(substr($today,4,2))-1;
				$sday = 1;
				$eyear = $syear;
				$emonth = $smonth+3;
				$eday = $sday;
				if ($smonth < 0)
				{
					$syear--;
					$smonth = 12-$smonth;
				}
				if ($emonth>12)
				{
					$eyear++;
					$emonth -= 12;
				} 
				$sb = CreateObject('phpgwapi.sbox');

				$var = Array(
					'header'	=> lang('Export from Calendar'),
					'navbar_bg' => $GLOBALS['phpgw_info']['theme']['navbar_bg'],
					'navbar_text' => $GLOBALS['phpgw_info']['theme']['navbar_text'],
					'lang_conv' => lang('Select the type of conversion'),
					'conv' => $conv,
					'startdate' => lang('Start Date'),
					'enddate' => lang('End Date'),
					'yearstart' => $syear,
					'yearend' => $eyear,
					'monthstart' => $smonth,
					'monthend' => $emonth,
					'daystart' => $sday,
					'dayend' => $eday,
					'lang_cancel' => lang('Cancel'),
					'cancel_url' => $GLOBALS['phpgw']->link('/index.php','menuaction=calendar.uicalendar.index'),
					'filename' => lang('Export file name'),
					'download' => lang('Submit'),
					'ical_lang'		=> lang('(i/v)Cal'),
					'action_url'	=> $GLOBALS['phpgw']->link('/index.php','menuaction=calendar.uiXport.export'),
					'lang_access'	=> lang('Access'),
					'lang_groups'	=> lang('Which groups'),
					'access_option'=> $access_option,
					'group_option'	=> $group_option,
					'start'  => $this->start,
					'sort' => $this->sort,
					'order' => $this->order,
					'filter' => $this->filter,
					'query' => $this->query,
					'load_vcal'	=> lang('Load [iv]Cal'),
					'startdata'	=> $GLOBALS['phpgw']->common->dateformatorder(
					   $sb->getYears('startdate[year]',$syear),
					   $sb->getMonthText('startdate[month]',$smonth),
					   $sb->getDays('startdate[mday]',$sday)),
					'enddata'	=> $GLOBALS['phpgw']->common->dateformatorder(
					   $sb->getYears('enddate[year]',$eyear),
					   $sb->getMonthText('enddate[month]',$emonth),
					   $sb->getDays('enddate[mday]',$eday))
				);

				$this->template->set_var($var);

				$this->template->pparse('out','export');
			}
		}


	}
?>
